/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Contents of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.42 - (show annotations) (download)
Sat Feb 17 01:07:48 2007 UTC (7 years, 6 months ago) by zzam
Branch: MAIN
Changes since 1.41: +7 -4 lines
Not using ROOT for header-checksum, as compile-process also not respect ROOT, Bug #167285.

1 # Copyright 1999-2005 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/vdr-plugin.eclass,v 1.41 2007/01/06 14:47:04 zzam Exp $
4 #
5 # Author:
6 # Matthias Schwarzott <zzam@gentoo.org>
7 # Joerg Bornkessel <hd_brummy@gentoo.org>
8
9 # vdr-plugin.eclass
10 #
11 # eclass to create ebuilds for vdr plugins
12 #
13
14 # Example ebuild (vdr-femon):
15 #
16 # inherit vdr-plugin
17 # IUSE=""
18 # SLOT="0"
19 # DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)"
20 # HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/"
21 # SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz"
22 # LICENSE="GPL-2"
23 # KEYWORDS="~x86"
24 # DEPEND=">=media-video/vdr-1.3.27"
25 #
26 #
27
28 # Installation of a config file for the plugin
29 #
30 # If ${VDR_CONFD_FILE} is set install this file
31 # else install ${FILESDIR}/confd if it exists.
32
33 # Gets installed as /etc/conf.d/vdr.${VDRPLUGIN}.
34 # For the plugin vdr-femon this would be /etc/conf.d/vdr.femon
35
36
37 # Installation of an rc-addon file for the plugin
38 #
39 # If ${VDR_RCADDON_FILE} is set install this file
40 # else install ${FILESDIR}/rc-addon.sh if it exists.
41 #
42 # Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
43 # (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
44 #
45 # This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
46 # It could be used for special startup actions for this plugins, or to create the
47 # plugin command line options from a nicer version of a conf.d file.
48
49 # HowTo use own local patches; Example
50 #
51 # Add to your /etc/make.conf:
52 # VDR_LOCAL_PATCHES_DIR="/usr/local/patch"
53 #
54 # Add two DIR's in your local patch dir, ${PN}/${PV},
55 # e.g for vdr-burn-0.1.0 should be:
56 # /usr/local/patch/vdr-burn/0.1.0/
57 #
58 # all patches which ending on diff or patch in this DIR will automatically applied
59 #
60
61 inherit base multilib eutils flag-o-matic
62
63 IUSE=""
64
65 # Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66 VDRPLUGIN="${PN/#vdrplugin-/}"
67 VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
68 VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
69
70 DESCRIPTION="vdr Plugin: ${VDRPLUGIN} (based on vdr-plugin.eclass)"
71
72 # works in most cases
73 S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74
75 # depend on headers for DVB-driver
76 RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1"
77 DEPEND="media-tv/linuxtv-dvb-headers"
78
79
80 # this code is from linux-mod.eclass
81 update_vdrplugindb() {
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
83
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR}
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92 }
93
94 remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi
101 }
102
103 # New method of storing plugindb
104 # Called from src_install
105 # file maintained by normal portage-methods
106 create_plugindb_file() {
107 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
108 local DB_FILE=${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}
109 insinto ${NEW_VDRPLUGINDB_DIR}
110 cat <<-EOT > ${D}/${DB_FILE}
111 VDRPLUGIN_DB=1
112 CREATOR=ECLASS
113 EBUILD=${CATEGORY}/${PN}
114 EBUILD_V=${PVR}
115 EOT
116 }
117
118 # Delete files created outside of vdr-plugin.eclass
119 # vdrplugin-rebuild.ebuild converted plugindb and files are
120 # not deleted by portage itself - should only be needed as
121 # long as not every system has switched over to
122 # vdrplugin-rebuild-0.2
123 delete_orphan_plugindb_file() {
124 #elog Testing for orphaned plugindb file
125 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
126 local DB_FILE=${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}
127
128 # file exists
129 [[ -f ${DB_FILE} ]] || return
130
131 # will portage handle the file itself
132 if grep -q CREATOR=ECLASS ${DB_FILE}; then
133 #elog file owned by eclass - don't touch it
134 return
135 fi
136
137 elog "Removing orphaned plugindb-file."
138 elog "\t#rm ${DB_FILE}"
139 rm ${DB_FILE}
140 }
141
142 vdr-plugin_pkg_setup() {
143 # -fPIC is needed for shared objects on some platforms (amd64 and others)
144 append-flags -fPIC
145
146 # Where should the plugins live in the filesystem
147 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
148 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
149
150 # was /usr/lib/... some time ago
151 # since gentoo-vdr-scripts-0.3.6 it works with /usr/share/...
152 VDR_RC_DIR="/usr/share/vdr/rcscript"
153
154 # Pathes to includes
155 VDR_INCLUDE_DIR="/usr/include/vdr"
156 DVB_INCLUDE_DIR="/usr/include"
157
158
159 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
160 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
161 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
162
163 einfo "Building ${PF} against vdr-${VDRVERSION}"
164 einfo "APIVERSION: ${APIVERSION}"
165 }
166
167 vdr-plugin_src_unpack() {
168 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
169 eerror "Wrong use of vdr-plugin.eclass."
170 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
171 echo
172 eerror "Please report this at bugs.gentoo.org."
173 die "vdr-plugin_pkg_setup not called!"
174 fi
175 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile
176
177 while [ "$1" ]; do
178
179 case "$1" in
180 all_but_unpack)
181 vdr-plugin_src_unpack add_local_patch patchmakefile
182 ;;
183 unpack)
184 base_src_unpack
185 ;;
186 patchmakefile)
187 if ! cd ${S}; then
188 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
189 ewarn "Perhaps you find one among these:"
190 cd "${WORKDIR}"
191 ewarn "$(/bin/ls -1 ${WORKDIR})"
192 die "Could not change to plugin-source-directory!"
193 fi
194
195 einfo "Patching Makefile"
196 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
197 cp Makefile Makefile.orig
198
199 sed -i Makefile \
200 -e '1i\#Makefile was patched by vdr-plugin.eclass'
201
202 ebegin " Setting Pathes"
203 sed -i Makefile \
204 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
205 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
206 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
207 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
208 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
209 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
210 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
211 eend $?
212
213 ebegin " Converting to APIVERSION"
214 sed -i Makefile \
215 -e 's:^APIVERSION = :APIVERSION ?= :' \
216 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
217 -e '2i\APIVERSION = '"${APIVERSION}"
218 eend $?
219
220 ebegin " Correcting Compile-Flags"
221 sed -i Makefile \
222 -e 's:^CXXFLAGS:#CXXFLAGS:' \
223 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
224 eend $?
225
226 ebegin " Disabling file stripping"
227 sed -i Makefile \
228 -e '/@.*strip/d' \
229 -e '/strip \$(LIBDIR)\/\$@/d' \
230 -e '/^STRIP =/d' \
231 -e '/@.*\$(STRIP)/d'
232 eend $?
233
234 # Use a file instead of an variable as single-stepping via ebuild
235 # destroys environment.
236 touch ${WORKDIR}/.vdr-plugin_makefile_patched
237 ;;
238 add_local_patch)
239 cd ${S}
240 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
241 echo
242 einfo "Applying local patches"
243 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
244 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
245 done
246 fi
247 ;;
248 esac
249
250 shift
251 done
252 }
253
254 vdr-plugin_copy_source_tree() {
255 pushd . >/dev/null
256 cp -r ${S} ${T}/source-tree
257 cd ${T}/source-tree
258 mv Makefile.orig Makefile
259 sed -i Makefile \
260 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
261 -e 's:^CXXFLAGS:#CXXFLAGS:' \
262 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
263 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
264 popd >/dev/null
265 }
266
267 vdr-plugin_install_source_tree() {
268 einfo "Installing sources"
269 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
270 insinto ${destdir}-${PV}
271 doins -r ${T}/source-tree/*
272
273 dosym ${VDRPLUGIN}-${PV} ${destdir}
274 }
275
276 vdr-plugin_src_compile() {
277 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
278
279 while [ "$1" ]; do
280
281 case "$1" in
282 prepare)
283 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
284 ;;
285 compile)
286 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
287 eerror "Wrong use of vdr-plugin.eclass."
288 eerror "An ebuild for a vdr-plugin will not work without"
289 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
290 echo
291 eerror "Please report this at bugs.gentoo.org."
292 die "vdr-plugin_src_unpack not called!"
293 fi
294 cd ${S}
295
296 emake ${BUILD_PARAMS} ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed"
297 ;;
298 esac
299
300 shift
301 done
302 }
303
304 vdr-plugin_src_install() {
305 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
306 cd ${S}
307
308 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
309 local mname=${P}-Makefile
310 cp Makefile ${mname}.patched
311 cp Makefile.orig ${mname}.before
312
313 diff -u ${mname}.before ${mname}.patched > ${mname}.diff
314
315 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
316 doins ${mname}.diff
317
318 insinto "/usr/share/vdr/maintainer-data/makefile-before"
319 doins ${mname}.before
320
321 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
322 doins ${mname}.patched
323
324 fi
325
326 insinto "${VDR_PLUGIN_DIR}"
327 doins libvdr-*.so.*
328 local docfile
329 for docfile in README* HISTORY CHANGELOG; do
330 [[ -f ${docfile} ]] && dodoc ${docfile}
331 done
332
333 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
334 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
335
336 if [[ -n ${VDR_CONFD_FILE} ]]; then
337 insinto /etc/conf.d
338 newins "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
339 fi
340
341
342 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
343 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
344
345 if [[ -n ${VDR_RCADDON_FILE} ]]; then
346 insinto "${VDR_RC_DIR}"
347 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
348 fi
349
350
351
352 # Danger: Not using $ROOT here, as compile will also not use it !!!
353 # If vdr in $ROOT and / differ, plugins will not run anyway
354
355 insinto ${VDR_CHECKSUM_DIR}
356 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
357 newins ${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}
358 else
359 if which md5sum >/dev/null 2>&1; then
360 cd ${S}
361 (
362 cd ${VDR_INCLUDE_DIR}
363 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
364 ) > header-md5-${PN}
365 doins header-md5-${PN}
366 fi
367 fi
368
369 create_plugindb_file
370 }
371
372 vdr-plugin_pkg_postinst() {
373 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
374 update_vdrplugindb
375 fi
376 elog
377 elog "The vdr plugin ${VDRPLUGIN} has now been installed."
378 elog "To activate execute the following command:"
379 elog
380 elog " emerge --config ${PN}"
381 elog
382 if [[ -n "${VDR_CONFD_FILE}" ]]; then
383 elog "And have a look at the config-file"
384 elog "/etc/conf.d/vdr.${VDRPLUGIN}"
385 elog
386 fi
387 }
388
389 vdr-plugin_pkg_postrm() {
390 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
391 remove_vdrplugindb
392 fi
393 delete_orphan_plugindb_file
394 }
395
396 vdr-plugin_pkg_config_final() {
397 diff ${conf_orig} ${conf}
398 rm ${conf_orig}
399 }
400
401 vdr-plugin_pkg_config_old() {
402 elog "Using interface of gentoo-vdr-scripts-0.3.6 and older"
403 if [[ -z "${INSTALLPLUGIN}" ]]; then
404 INSTALLPLUGIN="${VDRPLUGIN}"
405 fi
406 # First test if plugin is already inside PLUGINS
407 local conf=/etc/conf.d/vdr
408 conf_orig=${conf}.before_emerge_config
409 cp ${conf} ${conf_orig}
410
411 elog "Reading ${conf}"
412 if ! grep -q "^PLUGINS=" ${conf}; then
413 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
414 if [[ -n "${LINE}" ]]; then
415 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
416 else
417 echo 'PLUGINS=""' >> ${conf}
418 fi
419 unset LINE
420 fi
421
422 unset PLUGINS
423 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
424
425 active=0
426 for p in ${PLUGINS}; do
427 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
428 active=1
429 break;
430 fi
431 done
432
433 if [[ "${active}" == "1" ]]; then
434 elog "${INSTALLPLUGIN} already activated"
435 echo
436 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
437 if [[ "${answer}" != "yes" ]]; then
438 elog "aborted"
439 return
440 fi
441 elog "Removing ${INSTALLPLUGIN} from active plugins."
442 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
443 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
444 -e ${LINE}'s/ \( \)*/ /g' \
445 -e ${LINE}'s/ "/"/g' \
446 -e ${LINE}'s/" /"/g'
447
448 vdr-plugin_pkg_config_final
449 return
450 fi
451
452
453 elog "Adding ${INSTALLPLUGIN} to active plugins."
454 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
455 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
456 -e ${LINE}'s/ \( \)*/ /g' \
457 -e ${LINE}'s/ "/"/g' \
458 -e ${LINE}'s/" /"/g'
459
460 vdr-plugin_pkg_config_final
461 }
462
463 vdr-plugin_pkg_config_new() {
464 elog "Using interface introduced with gentoo-vdr-scripts-0.3.7"
465 if [[ -z "${INSTALLPLUGIN}" ]]; then
466 INSTALLPLUGIN="${VDRPLUGIN}"
467 fi
468
469 active=0
470 # First test if plugin is already inside PLUGINS
471 local conf=/etc/conf.d/vdr.plugins
472 exec 3<${conf}
473 while read -u 3 line; do
474 [[ ${line} == "" ]] && continue
475 [[ ${line:0:1} == "#" ]] && continue
476 set -- ${line}
477 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
478 done
479 exec 3<&-
480
481 if [[ $active == 0 ]]; then
482 elog "Adding ${INSTALLPLUGIN} to active plugins."
483
484 # The pure edit process.
485 echo "${INSTALLPLUGIN}" >> "${conf}"
486 else
487 elog "${INSTALLPLUGIN} already activated"
488 echo
489 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
490 if [[ "${answer}" != "yes" ]]; then
491 elog "aborted"
492 return
493 fi
494 elog "Removing ${INSTALLPLUGIN} from active plugins."
495
496 # The pure edit process
497 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
498 fi
499 }
500
501 vdr-plugin_pkg_config() {
502 if has_version ">media-tv/gentoo-vdr-scripts-0.3.6"; then
503 vdr-plugin_pkg_config_new
504 else
505 vdr-plugin_pkg_config_old
506 fi
507 }
508
509 fix_vdr_libsi_include()
510 {
511 einfo "Fixing include of libsi-headers"
512 local f
513 for f; do
514 sed -i "${f}" \
515 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
516 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
517 done
518 }
519
520 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config

  ViewVC Help
Powered by ViewVC 1.1.20